From f1330c6b6aadd68d0b8d8be5c732da7bc5b0948f Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 07 2015 22:33:58 +0000
Subject: [PATCH 95/254] Add an updates2stable widget for the user profile.


---

diff --git a/hubs/defaults.py b/hubs/defaults.py
index 7a2a619..baa60c6 100644
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -32,13 +32,19 @@ def add_user_widgets(session, hub, username, fullname):
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='workflow.pendingacls', index=2,
+        plugin='workflow.updates2stable', index=2,
         _config=json.dumps({
             'username': username,
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='badges', index=3,
+        plugin='workflow.pendingacls', index=3,
+        _config=json.dumps({
+            'username': username,
+        }))
+    hub.widgets.append(widget)
+    widget = hubs.models.Widget(
+        plugin='badges', index=4,
         _config=json.dumps({
             'username': username,
         }))
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index b00af22..e864e5b 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -9,6 +9,7 @@ from hubs.widgets import fedmsgs
 from hubs.widgets import fedmsgstats
 
 from hubs.widgets.workflow import pendingacls
+from hubs.widgets.workflow import updates2stable
 
 from hubs.widgets.base import AGPLv3, smartcache
 
@@ -23,6 +24,7 @@ registry = {
     'fedmsgs': fedmsgs,
     'fedmsgstats': fedmsgstats,
     'workflow.pendingacls': pendingacls,
+    'workflow.updates2stable': updates2stable,
 }
 
 
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
new file mode 100644
index 0000000..1b72c9d
--- /dev/null
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -0,0 +1,71 @@
+import requests
+
+from hubs.widgets.base import argument
+
+import jinja2
+
+
+import hubs.validators as validators
+
+# TODO -- add approve/deny buttons or just link through to pkgdb
+template = jinja2.Template("""
+<a class="btn btn-success" target="_blank" href="https://admin.fedoraproject.org/updates/mine">Manage updates</a>
+<hr/>
+<ul class="media-list">
+{% for update in updates %}
+    <li class="media">
+        <div class="media-left">
+            <a href="{{update['link']}}" target="_blank">
+                <img class="media-object img-responsive square-32" src="{{update['icon']}}"/>
+            </a>
+        </div>
+        <div class="media-body">
+            <h4 class="media-heading">{{update['title']}} (karma {{update['karma']}})</h4>
+            ready for love
+        </div>
+    </li>
+{% endfor %}
+</ul>
+""")
+
+from hubs.widgets.chrome import panel
+# If 'updates' is empty, then don't render any chrome.
+chrome = panel('Updates Ready for Stable', key='updates')
+
+
+@argument(name="username",
+          default=None,
+          validator=validators.username,
+          help="A FAS username.")
+def data(session, widget, username):
+
+    # First, get all of my updates currently in testing.
+    bodhiurl = 'https://admin.fedoraproject.org/updates/'
+    baseurl = bodhiurl + 'list'
+    query = '?username={username}&status=testing'.format(username=username)
+    url = baseurl + query
+    headers = {'Accept': 'application/json'}
+    response = requests.get(url, headers=headers)
+    data = response.json()
+
+    # Limit it this to only the updates that haven't already requested stable
+    # but which can actually be pushed to stable now.
+    giveaway = 'can be pushed to stable now'
+    data['updates'] = [
+        update for update in data['updates']
+        if update['request'] is None and
+        any([giveaway in comment['text'] for comment in update['comments']])
+    ]
+
+    # Stuff some useful information in there.
+    baseurl = 'https://apps.fedoraproject.org/packages/images/icons/'
+    for update in data['updates']:
+        package = update['builds'][0]['package']['name']
+        update['icon'] = baseurl + package + '.png'
+        update['link'] = bodhiurl + update['title']
+
+    return data
+
+
+def should_invalidate(message, session, widget):
+    raise NotImplementedError

